import {Observable} from "@nativescript/core";
import {AdditionalUserInfo, UserMetadata} from "@nativescript/firebase-auth";

export class User extends Observable {
  uid: string;
  email?: string;
  emailVerified: boolean;
  displayName?: string;
  phoneNumber?: string;
  anonymous: boolean;
  providers: Array<any>;
  photoURL?: string;
  metadata: UserMetadata;
  additionalUserInfo?: AdditionalUserInfo;


  constructor(data?: any) {
    super();

    data = data || {};

    this.uid = data.uid;
    this.email = data.email;
    this.emailVerified = data.emailVerified;
    this.displayName = data.displayName;
    this.phoneNumber = data.phoneNumber;
    this.anonymous = data.anonymous;
    this.providers = data.providers;
    this.photoURL = data.photoURL;
    this.metadata = data.metadata;
    this.additionalUserInfo = data.additionalUserInfo;
  }
}
