import {Application, LaunchEventData} from "@nativescript/core";
import '@nativescript/firebase-auth'; // only needs to be imported 1x
import {firebase} from '@nativescript/firebase-core';
import {state} from "~/state";
import {User} from "~/User";
import {IUser} from "@nativescript/firebase-auth/common";


Application.on(Application.launchEvent, (args: LaunchEventData) => {
  firebase().auth().addAuthStateChangeListener((user: IUser) => {
    console.log("############### onAuthStateChanged");
    console.log(user ? "Logged in to firebase" : "Logged out from firebase");

    if(user) {
      state.set("isLoggedIn", true);
      state.set("user", new User(user));
    } else {
      state.set("isLoggedIn", false);
    }
  });

  /*firebase.init({
    onAuthStateChanged: function(data: firebase.AuthStateData) { // optional but useful to immediately re-logon the user when they re-visit your app
      console.log("############### onAuthStateChanged");
      console.log(data.loggedIn ? "Logged in to firebase" : "Logged out from firebase");

      state.set("isLoggedIn", data.loggedIn === true);

      if(data.loggedIn === true) {
        state.set("user", new User(data.user));

        //now retrieve an auth token we can use to access Firebase from our server
        firebase.getAuthToken(
          {
            forceRefresh: false
          }).then((result: firebase.IdTokenResult) => {
          console.log("token: " + result.token);
          console.log("claims:");
          console.log(result.claims);
          console.log("authtime: " + new Date(result.authTime * 1000));
          console.log("expirationTime: " + new Date(result.expirationTime * 1000));
          console.log("signInProvider: " + result.signInProvider);
        }).catch((e) => {
          console.log("Auth token retrieval error: " + e)
        });
      } else {
        state.set("user", null);
      }
    }
  }).then(() => {
      console.log("firebase.init done");
  },
  (e) => {
    console.log("firebase.init error");
    console.log(e);
  });*/
});


Application.run({ moduleName: 'app-root' })
